# load the library
execfile('lib/jms-extend.py')

# connect to the admin instance of the domaine (to access all instances in one access point)
url='t3://localhost:7001'
username='weblogic'
password='weblogic'

# JMS module name used for the sample
modulename='SystemModule'

# source queue containing the messages to export in file format
instancename_dst='managed2'
jmsservername_dst='JMSServer-2'
queue_dst='LocalQueue'
distributed_dst=false
mbean_dst='/ServerRuntimes/%(instancename_dst)s/JMSRuntime/%(instancename_dst)s.jms/JMSServers/%(jmsservername_dst)s/Destinations/%(modulename)s!%(queue_dst)s' % locals()

# destination queue to import messages from files
instancename_src='managed1'
jmsservername_src='JMSServer-1'
queue_src='DistributedQueue'
distributed_src=true
mbean_src='/ServerRuntimes/%(instancename_src)s/JMSRuntime/%(instancename_src)s.jms/JMSServers/%(jmsservername_src)s/Destinations/%(modulename)s!%(jmsservername_src)s@%(queue_src)s' % locals()

# file and directory for the import/export
outputfile='E:/@_PROJETS/RECURANT/CNAM/CADRENAT/JMS/WORKING/messages/essai.xml'
outputdir='E:/@_PROJETS/RECURANT/CNAM/CADRENAT/JMS/WORKING/messages/essai'

# connect to the admin domaine
connexion = connect(username,password,url)





 
#IMPORT/EXPORT FROM FILE - START


# must be on a domain runtime to proceed
domainRuntime()

print "--- ### export all message from SRC to file/dir \n"

print "  - go to SRC MBean [%s] \n" % mbean_src
cdMbeanQueueDomainRuntime(distributed_src, instancename_src, jmsservername_src, modulename, queue_src )

print "  - lsMessages from SRC ...\n"
lsMessages()

print "  - exportQueueMessagesToFile ...\n"
exportQueueMessagesToFile( outputfile )

print "  - exportQueueMessagesToDir ...\n"
exportQueueMessagesToDir( outputdir )





print "--- ### import to DST from file/dir\n"

print "  - go to DST MBean [%s] \n" % mbean_dst
#cd(mbean_dst)
cdMbeanQueueDomainRuntime(distributed_dst, instancename_dst, jmsservername_dst, modulename, queue_dst )

print "  - importQueueMessagesFromFile ...\n"
importQueueMessagesFromFile( outputfile )

print "  - importQueueMessagesFromDir ...\n"
importQueueMessagesFromDir( outputdir )

print "  - RESULT ...\n"
print "  - lsMessages ...\n"
lsMessages()




ID=getFirtsFromListID()
print "--- ### get one message from the DST liste [ID=%s] ...\n" % ID

print "  - export [ID=%s]...\n" % ID
exportQueueMessageToFileById( ID, outputfile + ".uniq" )

print "  - deleteMessages ...\n"
deleteMessages()

print "  - lsMessages ...\n"
lsMessages()

print "  - importQueueMessagesFromFile ...\n"
importQueueMessagesFromFile( outputfile + ".uniq" )

print "  - lsMessages(one message [ID=%s]) ...\n" % ID
lsMessages()
ID=getFirtsFromListID()

print "  - deleteMessagesById(%s) ...\n" % ID
deleteMessagesById( ID )




print "--- ### pose/resume online queue ...\n"

print "  - poseAllOnlineQueue ...\n"
poseAllOnlineQueue()
print "  - resumeAllOnlineQueue ...\n"
resumeAllOnlineQueue()




print "--- ### pose/resume offline queue ...\n"

cdMbeanQueueEdit(distributed_dst, instancename_dst, jmsservername_dst, modulename, queue_dst )
print "  - pauseAllOfflineQueue ...\n"
pauseAllOfflineQueue()
print "  - resumeAllOfflineQueue ...\n"
resumeAllOfflineQueue()






#IMPORT/EXPORT FROM FILE - START

print "--- ### move messages from one queue to another directly ...\n"

domainRuntime()

print "  - popultate the SRC from file"
cdMbeanQueueDomainRuntime(distributed_src, instancename_src, jmsservername_src, modulename, queue_src )
deleteMessages()
importQueueMessagesFromFile( outputfile )
print "  - SRC populate"
lsMessages()

print "  - empty DST"
cdMbeanQueueDomainRuntime(distributed_dst, instancename_dst, jmsservername_dst, modulename, queue_dst )
deleteMessages()
lsMessages()

print "  - move the messages from the SRC to DST"
cdMbeanQueueDomainRuntime(distributed_dst, instancename_dst, jmsservername_dst, modulename, queue_dst )
target=cmo.getDestinationInfo()
cdMbeanQueueDomainRuntime(distributed_src, instancename_src, jmsservername_src, modulename, queue_src )
count=cmo.moveMessages('',target)
print "[%s]" % count

print "  - result SRC"
cdMbeanQueueDomainRuntime(distributed_src, instancename_src, jmsservername_src, modulename, queue_src )
lsMessages()

print "  - result DST"
cdMbeanQueueDomainRuntime(distributed_dst, instancename_dst, jmsservername_dst, modulename, queue_dst )
lsMessages()

disconnect('true')